- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# CFrame Class Reference

The CFrame is the parent container of all views. More...

`#include <vstgui.h>`

Inheritance diagram for CFrame:

List of all members.

## Public Member Functions
| CFrame (const CRect &size, void *pSystemWindow, void *pEditor)
| CFrame (const CRect &size, const char *pTitle, void *pEditor, const long style=0)
virtual | ~CFrame ()
virtual bool | open (CPoint *pPoint=0)
virtual bool | close ()
virtual bool | isOpen () const
virtual void | idle ()
virtual void | doIdleStuff ()
virtual unsigned long | getTicks () const
| get the current time (in ms)
virtual long | getKnobMode () const
| get hosts knob mode
virtual bool | setPosition (CCoord x, CCoord y)
virtual bool | getPosition (CCoord &x, CCoord &y) const
virtual bool | setSize (CCoord width, CCoord height)
virtual bool | getSize (CRect *pSize) const
virtual bool | getSize (CRect &pSize) const
virtual long | setModalView (CView *pView)
virtual CView * | getModalView () const
virtual void | beginEdit (long index)
virtual void | endEdit (long index)
virtual bool | getCurrentLocation (CPoint &where)
virtual void | setCursor (CCursorType type)
virtual void | setFocusView (CView *pView)
virtual CView * | getFocusView () const
virtual bool | advanceNextFocusView (CView *oldFocus, bool reverse=false)
virtual bool | setDropActive (bool val)
virtual bool | isDropActive () const
CDrawContext * | createDrawContext ()
virtual void | setOpenFlag (bool val)
virtual bool | getOpenFlag () const
virtual void | invalidate (const CRect &rect)
virtual bool | updatesDisabled () const
virtual bool | updatesDisabled (bool state)
void * | getSystemWindow () const
void * | getParentSystemWindow () const
void | setParentSystemWindow (void *val)
virtual void | draw (CDrawContext *pContext)
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
virtual void | draw (CView *pView=0)
virtual void | mouse (CDrawContext *pContext, CPoint &where, long buttons=-1)
| called if a mouse click event occurs
virtual bool | onWheel (CDrawContext *pContext, const CPoint &where, float distance)
| called if a mouse wheel event is happening over this view
virtual bool | onWheel (CDrawContext *pContext, const CPoint &where, const CMouseWheelAxis axis, float distance)
| called if a mouse wheel event is happening over this view
virtual long | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual long | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
virtual void | update (CDrawContext *pContext)
virtual void | setViewSize (CRect &inRect)
virtual CView * | getCurrentView () const
| get the current view under the mouse
virtual void * | getEditor () const
## Protected Member Functions
bool | initFrame (void *pSystemWin)
## Protected Attributes
void * | pEditor
void * | pSystemWindow
CView * | pModalView
CView * | pFocusView
bool | bFirstDraw
bool | bOpenFlag
bool | bDropActive
bool | bUpdatesDisabled

## Detailed Description

The CFrame is the parent container of all views.

It creates a platform dependend view object. On classic Mac OS it just draws into the provided window. On Mac OS X it is a ControlRef. On Windows it's a WS_CHILD Window.

## Constructor & Destructor Documentation

CFrame::CFrame | ( | const CRect & | size,
|  | void * | pSystemWindow,
|  | void * | pEditor
| ) |

CFrame::CFrame | ( | const CRect & | size,
|  | const char * | pTitle,
|  | void * | pEditor,
|  | const long | style = `0`
| ) |

CFrame::~CFrame | ( |  | ) | `[virtual]`

## Member Function Documentation

bool CFrame::advanceNextFocusView | ( | CView * | oldFocus,
|  | bool | reverse = `false`
| ) | `[virtual]`

| Reimplemented from CViewContainer.

void CFrame::beginEdit | ( | long | index | ) | `[virtual]`

bool CFrame::close | ( |  | ) | `[virtual]`

CDrawContext * CFrame::createDrawContext | ( |  | ) |

void CFrame::doIdleStuff | ( |  | ) | `[virtual]`

void CFrame::draw | ( | CView * | pView = `0` | ) | `[virtual]`

void CFrame::draw | ( | CDrawContext * | pContext | ) | `[virtual]`

  | Parameters:
  | pContext | the context which to use to draw this container and its subviews
Reimplemented from CViewContainer.

void CFrame::drawRect | ( | CDrawContext * | pContext,
|  | const CRect & | updateRect
| ) | `[virtual]`

  | Parameters:
  | pContext | the context which to use to draw
  | _updateRect | the area which to draw
Reimplemented from CViewContainer.

void CFrame::endEdit | ( | long | index | ) | `[virtual]`

bool CFrame::getCurrentLocation | ( | CPoint & | where | ) | `[virtual]`

CView * CFrame::getCurrentView | ( |  | ) | const`[virtual]`

| get the current view under the mouse Reimplemented from CViewContainer.

virtual void* CFrame::getEditor | ( |  | ) | const`[inline, virtual]`

| Reimplemented from CView.

virtual CView* CFrame::getFocusView | ( |  | ) | const`[inline, virtual]`

long CFrame::getKnobMode | ( |  | ) | const`[virtual]`

| get hosts knob mode

virtual CView* CFrame::getModalView | ( |  | ) | const`[inline, virtual]`

virtual bool CFrame::getOpenFlag | ( |  | ) | const`[inline, virtual]`

void* CFrame::getParentSystemWindow | ( |  | ) | const`[inline]`

bool CFrame::getPosition | ( | CCoord & | x,
|  | CCoord & | y
| ) | const`[virtual]`

bool CFrame::getSize | ( | CRect & | pSize | ) | const`[virtual]`

bool CFrame::getSize | ( | CRect * | pSize | ) | const`[virtual]`

void* CFrame::getSystemWindow | ( |  | ) | const`[inline]`

unsigned long CFrame::getTicks | ( |  | ) | const`[virtual]`

| get the current time (in ms)

void CFrame::idle | ( |  | ) | `[virtual]`

bool CFrame::initFrame | ( | void * | pSystemWin | ) | `[protected]`

void CFrame::invalidate | ( | const CRect & | rect | ) | `[virtual]`

virtual bool CFrame::isDropActive | ( |  | ) | const`[inline, virtual]`

virtual bool CFrame::isOpen | ( |  | ) | const`[inline, virtual]`

void CFrame::mouse | ( | CDrawContext * | pContext,
|  | CPoint & | where,
|  | long | buttons = `-1`
| ) | `[virtual]`

| called if a mouse click event occurs Reimplemented from CViewContainer.

long CFrame::onKeyDown | ( | VstKeyCode & | keyCode | ) | `[virtual]`

| called if a key down event occurs and this view has focus Reimplemented from CViewContainer.

long CFrame::onKeyUp | ( | VstKeyCode & | keyCode | ) | `[virtual]`

| called if a key up event occurs and this view has focus Reimplemented from CViewContainer.

bool CFrame::onWheel | ( | CDrawContext * | pContext,
|  | const CPoint & | where,
|  | const CMouseWheelAxis | axis,
|  | float | distance
| ) | `[virtual]`

| called if a mouse wheel event is happening over this view Reimplemented from CViewContainer.

bool CFrame::onWheel | ( | CDrawContext * | pContext,
|  | const CPoint & | where,
|  | float | distance
| ) | `[virtual]`

| called if a mouse wheel event is happening over this view Reimplemented from CViewContainer.

bool CFrame::open | ( | CPoint * | pPoint = `0` | ) | `[virtual]`

void CFrame::setCursor | ( | CCursorType | type | ) | `[virtual]`

bool CFrame::setDropActive | ( | bool | val | ) | `[virtual]`

void CFrame::setFocusView | ( | CView * | pView | ) | `[virtual]`

long CFrame::setModalView | ( | CView * | pView | ) | `[virtual]`

virtual void CFrame::setOpenFlag | ( | bool | val | ) | `[inline, virtual]`

void CFrame::setParentSystemWindow | ( | void * | val | ) | `[inline]`

bool CFrame::setPosition | ( | CCoord | x,
|  | CCoord | y
| ) | `[virtual]`

bool CFrame::setSize | ( | CCoord | width,
|  | CCoord | height
| ) | `[virtual]`

void CFrame::setViewSize | ( | CRect & | inRect | ) | `[virtual]`

  | Parameters:
  | rect | the new size of the container
Reimplemented from CViewContainer.

void CFrame::update | ( | CDrawContext * | pContext | ) | `[virtual]`

| Reimplemented from CViewContainer.

virtual bool CFrame::updatesDisabled | ( | bool | state | ) | `[inline, virtual]`

virtual bool CFrame::updatesDisabled | ( |  | ) | const`[inline, virtual]`

## Member Data Documentation

bool CFrame::bDropActive`[protected]`

bool CFrame::bFirstDraw`[protected]`

bool CFrame::bOpenFlag`[protected]`

bool CFrame::bUpdatesDisabled`[protected]`

void* CFrame::pEditor`[protected]`

CView* CFrame::pFocusView`[protected]`

CView* CFrame::pModalView`[protected]`

void* CFrame::pSystemWindow`[protected]`

The documentation for this class was generated from the following files:

- vstgui.h
- vstgui.cpp

Empty

Copyright ©2006 Steinberg Media Technologies. All Rights Reserved.